############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXNODE, NX protocol compression and NX extensions to this software      #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXPingMonitor;no warnings;(my $__pingTime=(0x0b3a+ 432-0x0cea));(my $__pongTime
=(0x0b72+ 2669-0x15df));(my $__interval=(0x1aa0+ 315-0x1bdb));(my $__timeout=
(0x029f+ 8514-0x23e1));(my $__errorTimeout=(0x111b+ 4398-0x2249));sub initialize
{__setTimeBetweenPings ();__setTimeoutForPingResponse ();__sendPing ();}sub 
__setTimeBetweenPings{($__interval=(0x0717+ 2893-0x1246));Logger::debug (((
"\x4e\x58\x50\x69\x6e\x67\x4d\x6f\x6e\x69\x74\x6f\x72\x3a\x20\x54\x69\x6d\x65\x20\x62\x65\x74\x77\x65\x65\x6e\x20\x70\x69\x6e\x67\x73\x20\x74\x6f\x20\x74\x68\x65\x20\x73\x65\x72\x76\x65\x72\x3a\x20"
.$__interval)."\x2e"));}sub __setTimeoutForPingResponse{if ((not ((
$GLOBAL::NodeConnectionTimeout=~ /\d+/ )))){Logger::warning (
"\x4e\x58\x50\x69\x6e\x67\x4d\x6f\x6e\x69\x74\x6f\x72\x3a\x20\x49\x6e\x76\x61\x6c\x69\x64\x20\x76\x61\x6c\x75\x65\x20\x66\x6f\x72\x20\x74\x68\x65\x20\x4e\x6f\x64\x65\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x54\x69\x6d\x65\x6f\x75\x74\x20\x6b\x65\x79\x2e\x20\x55\x73\x69\x6e\x67\x20\x64\x65\x66\x61\x75\x6c\x74\x2e"
);($GLOBAL::NodeConnectionTimeout=(0x1031+ 3477-0x1d4e));}($__timeout=
$GLOBAL::NodeConnectionTimeout);Logger::debug (((
"\x4e\x58\x50\x69\x6e\x67\x4d\x6f\x6e\x69\x74\x6f\x72\x3a\x20\x54\x69\x6d\x65\x6f\x75\x74\x20\x66\x6f\x72\x20\x70\x69\x6e\x67\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x3a\x20"
.$__timeout)."\x2e"));}sub checkTimesAndSendPingIfNecessary{if ((__isPingEnabled
 ()==(0x0579+ 2400-0x0ed9))){return;}if ((__isTimeoutForPingRespose ()==
(0x0632+ 4704-0x1891))){if ((__isErrorServerDidNotReply ()==
(0x02a0+ 1348-0x07e3))){Logger::error (((
"\x53\x65\x72\x76\x65\x72\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x70\x6c\x79\x20\x73\x69\x6e\x63\x65\x20"
.$__timeout).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e\x20\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x73\x65\x73\x73\x69\x6f\x6e\x2e"
));NXSessionMonitor::__setSessionStatus ($NXSessionMonitor::statusError,((
"\x4c\x6f\x73\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x4e\x58\x20\x73\x65\x72\x76\x65\x72\x3a\x20\x6e\x6f\x20\x72\x65\x70\x6c\x69\x65\x73\x20\x69\x6e\x20"
.$__timeout)."\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));return;}
__setErrorServerDidNotReply ();Logger::warning (((
"\x53\x65\x72\x76\x65\x72\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x70\x6c\x79\x20\x73\x69\x6e\x63\x65\x20"
.$__timeout)."\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));__sendPing ();return;}if (
(__isPingTime ()==(0x2187+ 952-0x253e))){__sendPing ();return;}}sub handlePong{
Logger::debug (
"\x52\x65\x63\x65\x69\x76\x65\x64\x20\x70\x6f\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x2e"
);__clearErrorServerDidNotReply ();__setPongTime ();__resetPingTime ();}sub 
handleRequestForPingMessage{Logger::debug (
"\x52\x65\x63\x65\x69\x76\x65\x64\x20\x72\x65\x71\x75\x65\x73\x74\x20\x66\x6f\x72\x20\x73\x65\x6e\x64\x20\x70\x69\x6e\x67\x20\x74\x6f\x20\x74\x68\x65\x20\x73\x65\x72\x76\x65\x72\x2e"
);__sendPing ();}sub __sendPing{Logger::debug (
"\x53\x65\x6e\x64\x69\x6e\x67\x20\x70\x69\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x2e"
);(my $message=(((("\x4e\x58\x3e\x20".$GLOBAL::MSG_NODE_PING)."\x20").
$GLOBAL::MESSAGES_FORMAT{$GLOBAL::MSG_NODE_PING})."\x0a"));(my $bytes=
main::nxwrite (main::nxgetSTDOUT (),$message));if (($bytes==(-
(0x231a+ 476-0x24f5)))){NXSessionMonitor::__setSessionStatus (
$NXSessionMonitor::statusError,
"\x4c\x6f\x73\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x4e\x58\x20\x73\x65\x72\x76\x65\x72\x2e\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x70\x69\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x74\x6f\x20\x73\x65\x72\x76\x65\x72\x2e"
);return;}__resetPongTime ();__setPingTime ();}sub __isPingEnabled{if ((
$__timeout==(0x04cc+ 6277-0x1d51))){return ((0x081b+ 848-0x0b6b));}return (
(0x0b19+ 5564-0x20d4));}sub __setPingTime{($__pingTime=
Common::NXTime::getSecondsSinceEpoch ());}sub __resetPingTime{($__pingTime=
(0x0bcd+ 3870-0x1aeb));}sub __isPingTime{if (($__pongTime==(0x0884+ 6369-0x2165)
)){return ((0x1063+ 4322-0x2145));}(my $time=
Common::NXTime::getSecondsSinceEpoch ());if (($time>=($__pongTime+$__interval)))
{return ((0x016a+ 6025-0x18f2));}return ((0x0f0d+ 1307-0x1428));}sub 
__isTimeoutForPingRespose{if (($__pingTime==(0x0944+ 3835-0x183f))){return (
(0x22cb+ 737-0x25ac));}(my $time=Common::NXTime::getSecondsSinceEpoch ());if ((
$__pingTime>$time)){($__pingTime=Common::NXTime::getSecondsSinceEpoch ());}if ((
$time>=($__pingTime+$__timeout))){return ((0x09b4+ 4082-0x19a5));}return (
(0x0aaf+ 6473-0x23f8));}sub __setErrorServerDidNotReply{($__errorTimeout=
(0x0627+ 6119-0x1e0d));}sub __isErrorServerDidNotReply{return ($__errorTimeout);
}sub __clearErrorServerDidNotReply{($__errorTimeout=(0x0ee8+ 5804-0x2594));}sub 
__setPongTime{($__pongTime=Common::NXTime::getSecondsSinceEpoch ());}sub 
__resetPongTime{($__pongTime=(0x06e5+ 6927-0x21f4));}return (
(0x198a+ 194-0x1a4b));
