############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package KeysManager;no warnings;(my $__maxRotatedFiles=(0x0e60+ 2251-0x1725));
sub __getBackupFileName{(my $name=shift (@_));($name.=
"\x2e\x62\x61\x63\x6b\x75\x70");if ((not (Common::NXFile::fileExists ($name)))){
return ($name);}(my $number=(0x00a5+ 2750-0x0b61));while (($number<=
$__maxRotatedFiles)){if ((not (Common::NXFile::fileExists (($name.$number))))){
return (($name.$number));}($number+=(0x0df6+ 2492-0x17b1));}($number=
(0x058b+ 7857-0x243b));(my $oldestFile=$name);(my $oldestCTime=
Common::NXCore::NXFileCTime ($name));while (($number<=$__maxRotatedFiles)){(my $cTime
=Common::NXCore::NXFileCTime (($name.$number)));if (($oldestCTime>$cTime)){(
$oldestFile=($name.$number));($oldestCTime=$cTime);}($number+=
(0x0222+ 7326-0x1ebf));}return ($oldestFile);}sub __backupKey{(my $file=shift (
@_));(my $backup=__getBackupFileName ($file));if (Common::NXFile::fileExists (
$file)){(my ($ret,$error)=Common::NXCore::copyFile ($file,$backup));if (($error 
ne (""))){Logger::warning ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x62\x61\x63\x6b\x75\x70\x20\x66\x69\x6c\x65\x2e\x20"
.$error));return ((0x015d+ 2281-0x0a45));}else{
Common::NXFile::setOwnerShipAndPermissionsReadOnlyForNX ($backup);}}return (
(0x08b8+ 3898-0x17f2));}sub __createRestore{(my $file=shift (@_));if ((not (
Common::NXFile::isExists ($file)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x73\x74\x6f\x72\x65\x20\x66\x69\x6c\x65\x2e\x20"
.$file)."\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"));
return ((0x1ad0+ 599-0x1d27));}(my $restore=($file.
"\x2e\x72\x65\x73\x74\x6f\x72\x65"));if (Common::NXFile::isExists ($restore)){
Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x73\x74\x6f\x72\x65\x20\x66\x69\x6c\x65\x2e\x20"
.$restore)."\x20\x65\x78\x69\x73\x74\x73\x2e"));return ((0x0b66+ 351-0x0cc5));}
if (Common::NXFile::fileExists ($file)){(my ($ret,$error)=
Common::NXCore::copyFile ($file,$restore));if (($error ne (""))){Logger::warning
 ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x73\x74\x6f\x72\x65\x20\x66\x69\x6c\x65\x2e\x20"
.$error));return ((0x05f5+ 3459-0x1377));}else{
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($restore);}}return
 ((0x13a4+ 4038-0x236a));}sub __createDefault{(my $file=shift (@_));(my $default
=shift (@_));if (Common::NXFile::fileExists ($default)){return (
(0x1c2f+ 711-0x1ef6));}if (Common::NXFile::fileExists ($file)){(my ($ret,$error)
=Common::NXCore::copyFile ($file,$default));if (($error ne (""))){
Logger::warning ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x66\x61\x75\x6c\x74\x20\x66\x69\x6c\x65\x2e\x20"
.$error));return ((0x0eea+ 3642-0x1d23));}else{
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($default);}}return
 ((0x066c+ 862-0x09ca));}sub backup{if ((__backupKey (NXPaths::getNodePublicKeys
 ())==(0x0bc5+ 5824-0x2284))){return ((0x0374+ 5872-0x1a63));}if ((__backupKey (
NXPaths::getUserDefaultRSAPublicKeyPath ())==(0x0556+ 2132-0x0da9))){return (
(0x0f5b+ 3288-0x1c32));}if ((__backupKey (NXPaths::getClientRSAPrivateKey ())==
(0x04dd+ 1096-0x0924))){return ((0x1870+ 2668-0x22db));}if ((__backupKey (
NXPaths::getClientRSADefaultPrivateKey ())==(0x08a1+ 241-0x0991))){return (
(0x0127+ 7331-0x1dc9));}if ((__backupKey (NXPaths::getClientDSADefaultPrivateKey
 ())==(0x0180+ 5095-0x1566))){return ((0x0d51+ 1711-0x13ff));}if ((
__createRestore (NXPaths::getClientRSAPrivateKey ())==(0x0626+ 3817-0x150e))){
return ((0x0938+ 4272-0x19e7));}return ((0x08c0+ 5246-0x1d3e));}sub 
__generateRSAKeys{(my $public=NXPaths::getUserNewRSAPublicKey ());(my $private=
NXPaths::getUserNewRSAPrivateKey ());return (__generateKeys ($public,$private,
"\x72\x73\x61"));}sub __generateKeys{(my $publicKeyFileName=shift (@_));(my $privateKeyFileName
=shift (@_));(my $algorithm=shift (@_));(my (@command)=());(my (@options)=());(my $selinuxenabled
=NXTools::getUnixCommandPath (
"\x73\x65\x6c\x69\x6e\x75\x78\x65\x6e\x61\x62\x6c\x65\x64"));if (
Common::NXFile::isExists ($selinuxenabled)){(@command=$selinuxenabled);(my $runcon
=NXTools::getUnixCommandPath ("\x72\x75\x6e\x63\x6f\x6e"));(my ($cmd_err,
$cmd_out,$exit_value)=main::run_command ((\@command),(\@options)));if ((
$exit_value==(0x10e2+ 2041-0x18db))){if (Common::NXFile::isExists ($runcon)){
push (@command,$runcon,"\x2d\x75","\x72\x6f\x6f\x74","\x2d\x72",
"\x73\x79\x73\x74\x65\x6d\x5f\x72","\x2d\x74","\x69\x6e\x69\x74\x72\x63\x5f\x74"
,"\x2d\x2d");}}else{Logger::debug2 (
"\x53\x65\x6c\x69\x6e\x75\x78\x20\x69\x73\x20\x64\x69\x73\x61\x62\x6c\x65\x64\x20\x69\x6e\x20\x74\x68\x69\x73\x20\x73\x79\x73\x74\x65\x6d"
);}}(@command=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);push (@command,
"\x2d\x6b",$privateKeyFileName,"\x2d\x74",$algorithm,"\x2d\x70",
$publicKeyFileName);push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x48\x4f\x4d\x45\x3d".NXPaths::getUserNXHomeDir ()));(my ($cmdErr,$cmdOut,
$exitValue)=main::nxRunCommand ((\@command),(\@options)));if (($exitValue!=
(0x0692+ 1455-0x0c41))){Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x6e\x65\x72\x61\x74\x65\x20".$algorithm).
"\x20\x6b\x65\x79\x20").$exitValue).
"\x2e\x20\x50\x6c\x65\x61\x73\x65\x20\x63\x68\x65\x63\x6b\x20\x74\x68\x65\x20\x27\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67\x27\x20\x66\x69\x6c\x65\x20\x66\x6f\x72\x20\x70\x6f\x73\x73\x69\x62\x6c\x65\x20\x69\x73\x73\x75\x65\x73\x2e"
));}return ($exitValue);}sub __getKeysFromFile{(my $keyFile=shift (@_));if ((not
 (Common::NXFile::isExists ($keyFile)))){return (undef);}(my (@keyLists)=());(my $fileFH
=Common::NXCore::nxopen ($keyFile,$NXBits::O_RDONLY,(0x0661+ 4352-0x1761)));if (
(not (defined ($fileFH)))){(my $error=libnxh::NXGetErrorName ());Logger::error (
((("\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27".
$keyFile)."\x27\x3a\x20").$error));return (undef);}while (
Common::NXCore::nxreadLine ($fileFH,(\$_))){($_=~ s/\r//g );chomp ($_);push (
@keyLists,$_);}Common::NXCore::nxclose ($fileFH);return (@keyLists);}sub 
__addPrefix{(my $file=shift (@_));(my (@keys)=__getKeysFromFile ($file));if ((
not (defined (@keys)))){return ((0x0852+ 1677-0x0ede));}(my $fh=
Common::NXCore::nxopen ($file,$NXBits::O_WRONLY,(0x1333+ 5074-0x2705)));if ((not
 (defined ($fh)))){(my $error=libnxh::NXGetErrorName ());Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20".$file).
"\x20\x74\x6f\x20\x77\x72\x69\x74\x65\x2e\x20").$error)."\x2e"));return (
(0x0c4f+ 5645-0x225b));}foreach my $key (@keys){($key=__getKeyWithPrefix ($key))
;if ((Common::NXCore::nxwrite ($fh,$key)==(-(0x0bf1+ 5054-0x1fae)))){(my $error=
libnxh::NXGetErrorName ());Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20"
.$file)."\x3a\x20").$error)."\x2e"));Common::NXCore::nxclose ($fh);return (
(0x0d8a+ 4104-0x1d91));}}Common::NXCore::nxclose ($fh);return (
(0x1d55+ 1033-0x215e));}sub __getKeyWithPrefix{(my $key=shift (@_));chomp ($key)
;chomp ($key);(my $keyWithPrefix.=
"\x6e\x6f\x2d\x70\x6f\x72\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c");
(my $path=NXPaths::getServerLaunchPath ());($keyWithPrefix.=((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x22".$path).
"\x20\x2d\x2d\x6c\x6f\x67\x69\x6e\x22\x20"));($keyWithPrefix.=$key);(
$keyWithPrefix.="\x0a");return ($keyWithPrefix);}sub generate{if (
isRSASuportedByServerConfig ()){if ((__generateRSAKeys ()>(0x0512+ 7918-0x2400))
){return ((0x0902+ 1218-0x0dc3));}if ((__addPrefix (
NXPaths::getUserNewRSAPublicKey ())==(0x15f0+ 3585-0x23f0))){return (
(0x03c9+ 715-0x0693));}}return ((0x02a1+ 6409-0x1baa));}sub __changeRSAPublicKey
{(my $file=NXPaths::getNodePublicKeys ());(my $oldKey=
NXPaths::getUserDefaultRSAPublicKeyPath ());if (Common::NXFile::isExists (
$oldKey)){if ((__removePublicKey ($file,$oldKey)==(0x08cc+ 5899-0x1fd6))){return
 ((0x09aa+ 3034-0x1583));}}(my $newKey=NXPaths::getUserNewRSAPublicKey ());if ((
__addPublicKey ($file,$newKey)==(0x114a+ 1753-0x1822))){return (
(0x1b39+ 2115-0x237b));}if ((__moveKey ($newKey,$oldKey)==(0x0c07+  10-0x0c10)))
{return ((0x15a0+ 3244-0x224b));}return ((0x0816+ 369-0x0987));}sub 
__removePublicKey{(my $file=shift (@_));(my $oldKeyFile=shift (@_));(my (
@oldKeys)=__getKeysFromFile ($oldKeyFile));if ((not (defined (@oldKeys)))){
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6f\x6c\x64\x20\x6b\x65\x79\x73\x20\x66\x6f\x72\x6d\x20\x66\x69\x6c\x65\x20"
.$oldKeyFile)."\x2e"));return ((0x012c+ 5243-0x15a6));}(my (@oldKeys)=
__getKeysFromFile ($oldKeyFile));foreach my $key (@oldKeys){__removePrefix ((
\$key));}foreach my $key (@oldKeys){if ((removeKeyFromFile ($key,$file,
"\x53\x53\x48")==(0x15b9+ 766-0x18b6))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x6f\x6c\x64\x20\x6b\x65\x79\x20\x66\x6f\x72\x6d\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e"));return ((0x1243+ 5269-0x26d7));}}return ((0x0f5b+ 2508-0x1927))
;}sub __removePrefix{(my $ref_key=shift (@_));if (($$ref_key=~ /(.*) (ssh-.*) (.*)/ )
){(my $type=$2);(my $value=$3);Logger::debug (((
"\x52\x65\x6d\x6f\x76\x65\x64\x20\x70\x72\x65\x66\x69\x78\x3a\x20".$1)."\x2e"));
($$ref_key=(($type."\x20").$value));}}sub __addPublicKey{(my $file=shift (@_));(my $newKeyFile
=shift (@_));(my (@newKeys)=__getKeysFromFile ($newKeyFile));if ((not (defined (
@newKeys)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6e\x65\x77\x20\x6b\x65\x79\x73\x20\x66\x6f\x72\x6d\x20\x66\x69\x6c\x65\x20"
.$newKeyFile)."\x2e"));return ((0x203f+ 516-0x2242));}(my $fh=
Common::NXCore::nxopen ($file,(($NXBits::O_CREAT+$NXBits::O_WRONLY)+
$NXBits::O_APPEND),$NXBits::UserReadWrite));if ((not (defined ($fh)))){(my $error
=libnxh::NXGetErrorName ());Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20".$file).
"\x20\x74\x6f\x20\x77\x72\x69\x74\x65\x2e\x20").$error)."\x2e"));return (
(0x0f87+ 3788-0x1e52));}foreach my $key (@newKeys){if ((Common::NXCore::nxwrite 
($fh,($key."\x0a"))==(-(0x0399+ 2726-0x0e3e)))){(my $error=
libnxh::NXGetErrorName ());Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20"
.$file)."\x3a\x20").$error)."\x2e"));Common::NXCore::nxclose ($fh);return (
(0x033a+ 6603-0x1d04));}}Common::NXCore::nxclose ($fh);if ((
Common::NXFile::setOwnerShipAndPermissionsReadOnlyForNX ($file)==(-
(0x1837+ 617-0x1a9f)))){return ((0x2616+ 139-0x26a0));}return (
(0x1830+ 3113-0x2459));}sub __changeRSAPrivateKey{(my $newFile=
NXPaths::getUserNewRSAPrivateKey ());(my $clientFile=
NXPaths::getClientRSAPrivateKey ());if ((__moveKey ($newFile,$clientFile)==
(0x0419+ 2933-0x0f8d))){return ((0x010a+ 1137-0x057a));}return (
(0x1965+ 3071-0x2564));}sub __moveKey{(my $from=shift (@_));(my $to=shift (@_));
if (Common::NXFile::fileExists ($from)){if ((Common::NXCore::moveFile ($from,$to
)==(0x0a91+ 281-0x0baa))){Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x6d\x6f\x76\x65\x20\x6b\x65\x79\x20\x66\x69\x6c\x65\x2e"
);return ((0x00b3+ 5531-0x164d));}}else{Logger::warning (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6d\x6f\x76\x65\x20\x66\x69\x6c\x65\x20".$from).
"\x2e\x20\x46\x69\x6c\x65\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"
));return ((0x11b6+ 481-0x1396));}return ((0x13fd+ 2613-0x1e32));}sub __copyKey{
(my $from=shift (@_));(my $to=shift (@_));if (Common::NXFile::fileExists ($from)
){(my ($ret,$error)=Common::NXCore::copyFile ($from,$to));if (($error ne (""))){
Logger::warning ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x70\x79\x20\x73\x73\x68\x20\x70\x75\x62\x6c\x69\x63\x20\x6b\x65\x79\x20\x66\x69\x6c\x65\x2e\x20"
.$error));return ((0x09d1+ 5266-0x1e62));}else{if ((
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($to)==(-
(0x0536+ 5969-0x1c86)))){Logger::warning (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x20\x66\x69\x6c\x65\x20"
.$to)."\x2e"));return ((0x102b+ 1545-0x1633));}}}else{Logger::warning (((
"\x53\x6f\x75\x72\x63\x65\x20\x6b\x65\x79\x20\x66\x69\x6c\x65\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x20"
.$from)."\x2e"));return ((0x1dcd+ 2351-0x26fb));}return ((0x0a26+ 5237-0x1e9b));
}sub change{if (isRSASuportedByServerConfig ()){if ((__changeRSAPublicKey ()==
(0x0840+ 2841-0x1358))){return ((0x106a+ 1611-0x16b4));}if ((
__changeRSAPrivateKey ()==(0x0c9c+ 6618-0x2675))){return ((0x0253+ 5165-0x167f))
;}}return ((0x1802+ 1218-0x1cc4));}sub __restoreRSAPublicKey{(my $file=
NXPaths::getNodePublicKeys ());(my $oldKey=
NXPaths::getUserDefaultRSAPublicKeyPath ());if (Common::NXFile::isExists (
$oldKey)){if ((__removePublicKey ($file,$oldKey)==(0x1f37+  63-0x1f75))){return 
((0x00a1+ 5156-0x14c4));}}(my $newKey=NXPaths::getRestoreRSAPublicKey ());if ((
__addPublicKey ($file,$newKey)==(0x0003+ 8835-0x2285))){return (
(0x0dbb+ 1298-0x12cc));}if ((__copyKey ($newKey,$oldKey)==(0x023d+ 6984-0x1d84))
){return ((0x00d7+ 4043-0x10a1));}return ((0x210d+ 1155-0x2590));}sub 
__restoreRSAPrivateKey{(my $restoreKey=NXPaths::getClientRSARestorePrivateKey ()
);(my $clientKey=NXPaths::getClientRSAPrivateKey ());if ((__copyKey ($restoreKey
,$clientKey)==(0x1a82+ 414-0x1c1f))){return ((0x02c6+ 2750-0x0d83));}return (
(0x04b9+ 6456-0x1df1));}sub restore{if (isRSASuportedByServerConfig ()){if ((
__restoreRSAPublicKey ()==(0x02dd+ 2076-0x0af8))){return ((0x0ac3+ 2507-0x148d))
;}if ((__restoreRSAPrivateKey ()==(0x0077+ 1779-0x0769))){return (
(0x0d6b+ 1031-0x1171));}}return ((0x03a1+ 325-0x04e6));}sub __isKeyInLine{(my $key
=shift (@_));(my $line=shift (@_));(my $protocol=shift (@_));($key=~ s/\r//g );(
$key=~ s/\n//g );chomp ($key);(my ($keyType,$keyValue)=split ( / / ,$key,
(0x0ba6+ 2451-0x1536)));($line=~ s/\r//g );($line=~ s/\n//g );chomp ($line);(my (
@lineFields)=split ( / / ,$line,(0x019d+ 6664-0x1ba5)));if (($protocol eq 
"\x53\x53\x48")){if ((($keyType eq $lineFields[(0x1efd+ 1564-0x2517)])and (
$keyValue eq $lineFields[(0x121a+ 1481-0x17e0)]))){Logger::debug (((
"\x4b\x65\x79\x20\x27".$key).
"\x27\x20\x6b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));return ((0x094c+ 167-0x09f2));}if ((($keyType eq $lineFields[
(0x0892+ 1249-0x0d72)])and ($keyValue eq $lineFields[(0x0c69+ 5410-0x2189)]))){
Logger::debug ((("\x4b\x65\x79\x20\x27".$key).
"\x27\x20\x6b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));return ((0x0177+ 1690-0x0810));}}else{if ((($keyType eq $lineFields[
(0x1784+ 443-0x193f)])and ($keyValue eq $lineFields[(0x023c+ 800-0x055b)]))){
Logger::debug ((("\x4b\x65\x79\x20\x27".$key).
"\x27\x20\x6b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));return ((0x1330+ 3662-0x217d));}}return ((0x1ad9+ 1042-0x1eeb));}sub 
__isAnyKeyInLine{(my $line=shift (@_));(my $protocol=shift (@_));($line=~ s/\r//g )
;($line=~ s/\n//g );chomp ($line);(my (@lineFields)=split ( / / ,$line,
(0x0a70+ 3685-0x18d5)));if (($protocol eq "\x53\x53\x48")){if ((($lineFields[
(0x0302+ 231-0x03e7)]ne (""))and ($lineFields[(0x02dc+ 4752-0x1569)]ne ("")))){
Logger::debug (
"\x4b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e");
return ((0x2217+ 1046-0x262c));}if ((($lineFields[(0x1b0f+ 920-0x1ea6)]ne (""))
and ($lineFields[(0x08d4+ 418-0x0a74)]ne ("")))){Logger::debug (
"\x4b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e");
return ((0x00f6+  74-0x013f));}}else{if ((($lineFields[(0x0244+ 3053-0x0e31)]ne 
(""))and ($lineFields[(0x1764+ 3461-0x24e8)]ne ("")))){Logger::debug (
"\x4b\x65\x79\x20\x6b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
);return ((0x0923+ 7201-0x2543));}}return ((0x14c1+ 2997-0x2076));}sub 
removeKeyFromFile{(my $keyToRemove=shift (@_));(my $filePath=shift (@_));(my $protocol
=shift (@_));(my $tempFilePath=(($filePath."\x2e\x74\x6d\x70\x2e").$ $));
 (my $fileFH
=Common::NXCore::nxopen ($filePath,$NXBits::O_RDONLY,(0x04d0+ 1705-0x0b79)));if 
((not (defined ($fileFH)))){(my $error=libnxh::NXGetErrorName ());Logger::error 
(((("\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27".
$filePath)."\x27\x3a\x20").$error));return ((0x2031+ 319-0x216f));}(my $tempFileFH
=Common::NXCore::nxopen ($tempFilePath,(($NXBits::O_CREAT+$NXBits::O_WRONLY)+
$NXBits::O_APPEND),$NXBits::UserReadWrite));if ((not (defined ($tempFileFH)))){(my $error
=libnxh::NXGetErrorName ());Logger::error ((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x74\x65\x6d\x70\x6f\x72\x61\x72\x79\x20\x66\x69\x6c\x65\x20\x27"
.$tempFilePath)."\x27\x3a\x20").$error));return ((0x19f2+ 830-0x1d2f));}while (
Common::NXCore::nxreadLine ($fileFH,(\$_))){(my $line=$_);if (__isKeyInLine (
$keyToRemove,$line,$protocol)){Logger::debug (((
"\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x6b\x65\x79\x20\x27".$line)."\x27\x2e"));}
else{Common::NXCore::nxwrite ($tempFileFH,$line);}}Common::NXCore::nxclose (
$tempFileFH);Common::NXCore::nxclose ($fileFH);if ((Common::NXFile::renameFile (
$tempFilePath,$filePath)==(0x0f40+ 1705-0x15e9))){return ((0x1915+ 649-0x1b9d));
}if ((Common::NXFile::setOwnerShipAndPermissionsForNX ($filePath)==(-
(0x034c+ 4427-0x1496)))){return ((0x0e8a+ 1868-0x15d5));}return (
(0x09d4+ 2303-0x12d3));}sub isKeyInFile{(my $key=shift (@_));(my $keyFile=shift 
(@_));(my $protocol=shift (@_));(my (@listSupportedKeys)=__getKeysFromFile (
$keyFile));foreach my $line (@listSupportedKeys){if (__isKeyInLine ($key,$line,
$protocol)){Logger::debug (
"\x4b\x65\x79\x20\x69\x73\x20\x69\x6e\x20\x74\x68\x65\x20\x66\x69\x6c\x65\x2e");
return ((0x0205+ 8439-0x22fb));}}Logger::debug (
"\x4b\x65\x79\x20\x69\x73\x20\x75\x6e\x69\x71\x75\x65\x2e");return (
(0x0580+ 5721-0x1bd9));}sub restorePrivateKey{(my $privateKey=
NXPaths::getClientPrivateKey ());(my $defaultPrivateKey=
NXPaths::getClientDefaultPrivateKey ());(my $restore=($privateKey.
"\x2e\x72\x65\x73\x74\x6f\x72\x65"));if (Common::NXFile::fileExists ($restore)){
copyKeyFile ($restore,$privateKey);copyKeyFile ($restore,$defaultPrivateKey);}}
sub isNotExistNodePublicKey{if (((not (Common::NXFile::isExists (
NXPaths::getNodePublicKeys ())))and (not (Common::NXFile::isExists (
NXPaths::getNXAuthorizedKeysPath ("\x6e\x78")))))){return ((0x1c94+ 2597-0x26b8)
);}if (Common::NXFile::isExists (NXPaths::getNXAuthorizedKeysPath ("\x6e\x78")))
{(my (@listSupportedKeys)=__getKeysFromFile (NXPaths::getNXAuthorizedKeysPath (
"\x6e\x78")));foreach my $line (@listSupportedKeys){if (__isAnyKeyInLine ($line,
"\x4e\x58")){Logger::debug (
"\x46\x6f\x75\x6e\x64\x20\x4e\x58\x20\x6b\x65\x79\x2e");return (
(0x05ab+ 5851-0x1c86));}}}if (Common::NXFile::isExists (
NXPaths::getNodePublicKeys ())){(my (@listSupportedKeys)=__getKeysFromFile (
NXPaths::getNodePublicKeys ()));foreach my $line (@listSupportedKeys){if (
__isAnyKeyInLine ($line,"\x53\x53\x48")){Logger::debug (
"\x46\x6f\x75\x6e\x64\x20\x53\x53\x48\x20\x6b\x65\x79\x2e");return (
(0x0e04+ 690-0x10b6));}}}return ((0x000d+ 5774-0x169a));}sub 
getSupportedSSHDKeyExchangeAlgorithm{if ((
$GLOBAL::SupportedSSHDKeyExchangeAlgorithm=~ /DSA|RSA|all|DSA,RSA|RSA,DSA/ )){
return ($GLOBAL::SupportedSSHDKeyExchangeAlgorithm);}else{Logger::warning (((
"\x57\x72\x6f\x6e\x67\x20\x76\x61\x6c\x75\x65\x20\x66\x6f\x72\x20\x6b\x65\x79\x3a\x20\x53\x75\x70\x70\x6f\x72\x74\x65\x64\x53\x53\x48\x44\x4b\x65\x79\x45\x78\x63\x68\x61\x6e\x67\x65\x41\x6c\x67\x6f\x72\x69\x74\x68\x6d\x3a\x20"
.$GLOBAL::SupportedSSHDKeyExchangeAlgorithm).
"\x20\x75\x73\x65\x20\x61\x6c\x6c\x2e"));return ("\x61\x6c\x6c");}}sub 
isDSASuportedByServerConfig{(my $supportedKeyList=
getSupportedSSHDKeyExchangeAlgorithm ());if (($supportedKeyList=~ /DSA/ )){
return ((0x15c8+ 892-0x1943));}if (($supportedKeyList eq "\x61\x6c\x6c")){return
 ((0x11e7+ 2044-0x19e2));}return ((0x0d71+ 5009-0x2102));}sub 
isRSASuportedByServerConfig{(my $supportedKeyList=
getSupportedSSHDKeyExchangeAlgorithm ());if (($supportedKeyList=~ /RSA/ )){
return ((0x0661+ 653-0x08ed));}if (($supportedKeyList eq "\x61\x6c\x6c")){return
 ((0x02c6+ 6595-0x1c88));}return ((0x1a14+ 853-0x1d69));}sub add{(my $ref_parameters
=shift (@_));($$ref_parameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}=uc (
$$ref_parameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}));if (($$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}eq (""))){($$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}="\x4e\x58");}unless (__getKey (
$ref_parameters)){return ((0x0c3a+ 3988-0x1bce));}unless (prepareKey (
$ref_parameters)){return ((0x0ed8+ 2628-0x191c));}unless (setKey (
$ref_parameters)){return ((0x107b+ 4923-0x23b6));}NXMsg::send_response (
"\x69\x43\x4d\x44\x50\x75\x62\x6c\x69\x63\x4b\x65\x79\x41\x64\x64\x65\x64\x4f\x6b"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$$ref_parameters{
"\x61\x75\x74\x68\x46\x69\x6c\x65"});return ((0x085d+ 1077-0x0c91));}sub 
__getKey{(my $ref_parameters=shift (@_));if (($$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"}ne (""))){unless (__getKeyFromFile (
$ref_parameters)){return ((0x0bec+ 4402-0x1d1e));}return ((0x0adc+ 2021-0x12c0))
;}unless (__getKeyFromSTDIN ($ref_parameters)){return ((0x04ff+ 2302-0x0dfd));}
return ((0x06df+ 2971-0x1279));}sub __getKeyFromFile{(my $ref_parameters=shift (
@_));unless (Common::NXFile::isExists ($$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"})){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x4e\x6f\x74\x45\x78\x69\x73\x74"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"});return ((0x098f+ 2354-0x12c1));}(my $INFILE=
Common::NXCore::nxopen ($$ref_parameters{"\x6b\x65\x79\x46\x69\x6c\x65"},
$NXBits::O_RDONLY));unless (defined ($INFILE)){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x52\x65\x61\x64"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"});return ((0x11da+ 4458-0x2344));}if ((
Common::NXCore::nxread ($INFILE,(\$$ref_parameters{"\x6b\x65\x79"}))==
(0x0ca1+ 4673-0x1ee2))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x45\x6d\x70\x74\x79\x46\x69\x6c\x65"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"});Common::NXCore::nxclose ($INFILE);return (
(0x18ea+ 2047-0x20e9));}Logger::debug ((((("\x4b\x65\x79\x20\x27".
$$ref_parameters{"\x6b\x65\x79"}).
"\x27\x20\x72\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x66\x69\x6c\x65\x20\x27").
$$ref_parameters{"\x6b\x65\x79\x46\x69\x6c\x65"})."\x27\x2e"));
Common::NXCore::nxclose ($INFILE);return ((0x08bb+ 3217-0x154b));}sub 
__getKeyFromSTDIN{(my $ref_parameters=shift (@_));(my $message=
"\x4e\x58\x3e\x20\x39\x32\x33\x20\x50\x6c\x65\x61\x73\x65\x20\x65\x6e\x74\x65\x72\x20\x74\x68\x65\x20\x73\x73\x68\x2d\x64\x73\x73\x20\x6b\x65\x79\x3a"
);(my $bytes=main::nxwrite (main::nxgetSTDOUT (),$message));unless (($bytes>
(0x15c1+ 2855-0x20e8))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6b\x65\x79\x20\x72\x65\x71\x75\x65\x73\x74\x20\x6f\x6e\x20\x53\x54\x44\x4f\x55\x54\x2e"
);return ((0x1dc4+ 655-0x2053));}(($$ref_parameters{"\x6b\x65\x79"},
$$ref_parameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$$ref_parameters{
"\x75\x75\x69\x64"})=__retrieveKey ());if (($$ref_parameters{"\x6b\x65\x79"}eq 
(""))){Logger::error (
"\x50\x75\x62\x6c\x69\x63\x20\x6b\x65\x79\x20\x6e\x6f\x74\x20\x70\x72\x6f\x76\x69\x64\x65\x64\x2e"
);return ((0x0bf9+ 409-0x0d92));}($$ref_parameters{"\x6b\x65\x79"}.="\x0a");
return ((0x01ac+ 7418-0x1ea5));}sub prepareKey{(my $ref_parameters=shift (@_));(my $proto
=$$ref_parameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"});if (($proto eq "\x4e\x58"
)){(my $authFile=NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));(my $authDir=
Common::NXFile::dirname ($authFile));Logger::debug (((
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x41\x75\x74\x68\x6f\x72\x69\x7a\x65\x64\x20\x6b\x65\x79\x73\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20\x27"
.$authDir)."\x27\x2e"));if ((not (Common::NXFile::directoryExists ($authDir)))){my (
$error);unless (Common::NXPaths::createAccessibleForNXDirectory ((\$error),
$authDir)){NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x44\x69\x72"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$proto,$authDir);return ((0x0ab8+ 6128-0x22a8));
}}($$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"}=$authFile);Logger::debug
 (((
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x41\x75\x74\x68\x6f\x72\x69\x7a\x65\x64\x20\x6b\x65\x79\x73\x20\x66\x69\x6c\x65\x20\x27"
.$$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"})."\x27\x2e"));}elsif ((
$proto eq "\x53\x53\x48")){($$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"}
=NXPaths::getNodePublicKeys ());if (isKeyInFile ($$ref_parameters{"\x6b\x65\x79"
},$$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"},$proto)){
removeKeyFromFile ($$ref_parameters{"\x6b\x65\x79"},$$ref_parameters{
"\x61\x75\x74\x68\x46\x69\x6c\x65"},$proto);}}else{NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x55\x6e\x6b\x6e\x6f\x77\x6e\x50\x72\x6f\x74\x6f"
,"\x4e\x58\x53\x68\x65\x6c\x6c");return ((0x0ccc+ 848-0x101c));}if (
Common::NXFile::isExists ($$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"}))
{if ((Common::NXFile::setPermissionsReadWriteForNX ($$ref_parameters{
"\x61\x75\x74\x68\x46\x69\x6c\x65"})==(-(0x0600+ 2482-0x0fb1)))){NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x50\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$proto,$$ref_parameters{
"\x61\x75\x74\x68\x46\x69\x6c\x65"});return ((0x0f92+ 378-0x110c));}}return (
(0x17e9+ 1698-0x1e8a));}sub setKey{(my $ref_parameters=shift (@_));(my $filepath
=$$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"});(my $mode=((
$NXBits::O_WRONLY+$NXBits::O_CREAT)+$NXBits::O_APPEND));(my $permissions=
$NXBits::UserReadWrite);(my $OUTFILE=Common::NXCore::nxopen ($filepath,$mode,
$permissions));unless (defined ($OUTFILE)){(my $errorString=
libnxh::NXGetErrorName ());NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x54\x6f\x57\x72\x69\x74\x65"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$filepath);return ((0x2382+ 530-0x2594));}(my $keyToSave
=$$ref_parameters{"\x6b\x65\x79"});if (($$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}eq "\x53\x53\x48")){($keyToSave=
NXNodeExec::addPrefixForSSHKey ($$ref_parameters{"\x6b\x65\x79"}));}if ((
Common::NXCore::nxwrite ($OUTFILE,$keyToSave)==(-(0x0090+ 9767-0x26b6)))){
NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x57\x72\x69\x74\x65"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$filepath);Common::NXCore::nxclose ($OUTFILE
);return ((0x0057+ 3041-0x0c38));}Common::NXCore::nxclose ($OUTFILE);if ((
Common::NXFile::setOwnerShipAndPermissionsForNX ($filepath)==(-
(0x019f+ 8441-0x2297)))){NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x50\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$filepath);return ((0x124d+ 4466-0x23bf));}
if (($$ref_parameters{"\x75\x75\x69\x64"}ne (""))){NXNodes::setAccessKey (
$$ref_parameters{"\x75\x75\x69\x64"},$$ref_parameters{"\x6b\x65\x79"});}return (
(0x126a+ 148-0x12fd));}sub __retrieveKey{(my $selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;(my $signalFd=$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});($$NXBegin::parser
{"\x73\x69\x67\x62\x61\x63\x6b"}{"\x49\x4e\x54"}=sub{Common::NXCore::nxexit ();}
);$selector->add ($signalFd);$selector->add (main::nxgetSTDIN ());(my $key=(""))
;(my $protocol=(""));(my $finish=(0x1d98+ 1446-0x233e));while (($finish==
(0x0ad1+ 5393-0x1fe2))){(my (@ready)=$selector->can_read ((0x18d6+ 2836-0x1062))
);if ((scalar (@ready)==(0x159f+ 833-0x18e0))){Logger::debug (
"\x4e\x6f\x74\x68\x69\x6e\x67\x20\x74\x6f\x20\x72\x65\x61\x64\x2e");($finish=
(0x1245+ 2540-0x1c30));}foreach my $fh (@ready){Logger::debug (((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x46\x44\x23".$fh)."\x2e"));if (($fh==
main::nxgetSTDIN ())){my ($read_buf);(my $bytes_read=main::nxread ($fh,(
\$read_buf),4096));Logger::debug (((
"\x52\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x53\x54\x44\x49\x4e\x20\x27".$read_buf
)."\x27\x2e"));if (($read_buf=~ /NX> params=(.*) / )){(my (%hashParameters)=
NXShell::urlParameter2Hash ($1));($key=$hashParameters{"\x6b\x65\x79"});(
$protocol=$hashParameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"});($uuid=
$hashParameters{"\x75\x75\x69\x64"});$selector->remove (main::nxgetSTDIN ());
$selector->remove ($signalFd);($finish=(0x0c83+ 515-0x0e85));}elsif ((
$bytes_read==(0x044b+ 493-0x0638))){$selector->remove (main::nxgetSTDIN ());
$selector->remove ($signalFd);($finish=(0x11b9+ 466-0x138a));}}}}return ($key,
$protocol,$uuid);}NXMsg::register_response (
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x41\x64\x64\x69\x6e\x67\x4b\x65\x79",(0x0461+ 2245-0x0c8c));
NXMsg::register_response ("\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x50\x75\x62\x6c\x69\x63\x4b\x65\x79\x41\x64\x64\x65\x64\x4f\x6b"
,(0x09f7+ 2707-0x13ef));NXMsg::register_error (
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x4e\x6f\x74\x45\x78\x69\x73\x74"
,(0x1601+ 4912-0x26ed));NXMsg::register_error (
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x52\x65\x61\x64"
,(0x0ca3+ 338-0x0bb1));NXMsg::register_error (
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x45\x6d\x70\x74\x79\x46\x69\x6c\x65"
,(0x1a84+ 1413-0x1dc5));return ((0x01c5+ 3254-0x0e7a));
