############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXDebugManager;no warnings;($__serverLogLevelKey=
"\x53\x65\x73\x73\x69\x6f\x6e\x4c\x6f\x67\x4c\x65\x76\x65\x6c");(
$__webplayerLogLevelKey=
"\x57\x65\x62\x53\x65\x73\x73\x69\x6f\x6e\x4c\x6f\x67\x4c\x65\x76\x65\x6c");(
$__agentLogCleanKey=
"\x53\x65\x73\x73\x69\x6f\x6e\x4c\x6f\x67\x43\x6c\x65\x61\x6e");(
$__syslogSupportKey=
"\x45\x6e\x61\x62\x6c\x65\x53\x79\x73\x6c\x6f\x67\x53\x75\x70\x70\x6f\x72\x74");
sub enable{(my $ref_parameters=shift (@_));if ((($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"}eq "\x61\x6c\x6c")or ($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"}eq ("")))){(my $result=__enableDebugAll (
$ref_parameters));warnIfSyslogEnabled ($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"});return ($result);}elsif (($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"}eq "\x73\x65\x72\x76\x65\x72")){(my $result=
__enableDebugServer ($ref_parameters));warnIfSyslogEnabled ($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"});return ($result);}elsif (($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"}eq "\x6e\x6f\x64\x65")){(my $result=__enableDebugNode
 ());warnIfSyslogEnabled ($$ref_parameters{"\x65\x6e\x61\x62\x6c\x65"});return (
$result);}elsif (($$ref_parameters{"\x65\x6e\x61\x62\x6c\x65"}eq 
"\x77\x65\x62\x70\x6c\x61\x79\x65\x72")){if (NXLicense::isHttpdSupportFeature ()
){(my $result=__enableDebugWebPlayer ());warnIfSyslogEnabled ($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"});return ($result);}else{NXMsg::error (
"\x65\x53\x65\x72\x76\x69\x63\x65\x4e\x6f\x74\x41\x76\x61\x69\x6c\x61\x62\x6c\x65"
,"\x6d\x61\x69\x6e","\x77\x65\x62\x70\x6c\x61\x79\x65\x72");}}elsif ((
$$ref_parameters{"\x65\x6e\x61\x62\x6c\x65"}eq "\x61\x67\x65\x6e\x74")){return (
__enableDebugAgent ());}elsif (($$ref_parameters{"\x65\x6e\x61\x62\x6c\x65"}eq 
"\x64\x61\x65\x6d\x6f\x6e")){my (%info);($info{"\x6c\x65\x76\x65\x6c"}=
Logger::getDebugLevel ());($info{"\x74\x69\x6d\x65\x6f\x75\x74"}=((
$GLOBAL::TimeoutToWaitForDaemonReady *(0x06a6+ 9245-0x26db))*
(0x1636+ 3100-0x224d)));NXClientSystemDaemons::askNXServerDaemonForSetLogLevel (
(\%info));NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x64\x61\x65\x6d\x6f\x6e");return;}return ((0x0d32+ 3819-0x1c1c));}sub disable{
(my $ref_parameters=shift (@_));if ((($$ref_parameters{
"\x64\x69\x73\x61\x62\x6c\x65"}eq "\x61\x6c\x6c")or ($$ref_parameters{
"\x64\x69\x73\x61\x62\x6c\x65"}eq ("")))){return (__disableDebugAll (
$ref_parameters));}elsif (($$ref_parameters{"\x64\x69\x73\x61\x62\x6c\x65"}eq 
"\x73\x65\x72\x76\x65\x72")){return (__disableDebugServer ($ref_parameters));}
elsif (($$ref_parameters{"\x64\x69\x73\x61\x62\x6c\x65"}eq "\x6e\x6f\x64\x65")){
return (__disableDebugNode ($ref_parameters));}elsif (($$ref_parameters{
"\x64\x69\x73\x61\x62\x6c\x65"}eq "\x77\x65\x62\x70\x6c\x61\x79\x65\x72")){if (
NXLicense::isHttpdSupportFeature ()){return (__disableDebugWebPlayer ());}else{
NXMsg::error (
"\x65\x53\x65\x72\x76\x69\x63\x65\x4e\x6f\x74\x41\x76\x61\x69\x6c\x61\x62\x6c\x65"
,"\x6d\x61\x69\x6e","\x77\x65\x62\x70\x6c\x61\x79\x65\x72");}}elsif ((
$$ref_parameters{"\x64\x69\x73\x61\x62\x6c\x65"}eq "\x61\x67\x65\x6e\x74")){
return (__disableDebugAgent ());}elsif (($$ref_parameters{
"\x64\x69\x73\x61\x62\x6c\x65"}eq "\x64\x61\x65\x6d\x6f\x6e")){my (%info);($info
{"\x6c\x65\x76\x65\x6c"}=Logger::getInfoLevel ());($info{
"\x74\x69\x6d\x65\x6f\x75\x74"}=(($GLOBAL::TimeoutToWaitForDaemonReady *
(0x0c46+ 2866-0x1390))*(0x1b2f+ 1154-0x1fac)));
NXClientSystemDaemons::askNXServerDaemonForSetLogLevel ((\%info));NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x64\x61\x65\x6d\x6f\x6e");return;}return ((0x05a3+ 1901-0x0d0f));}sub 
__enableDebugAll{(my $ref_parameters=shift (@_));if (defined ($$ref_parameters{
"\x64\x79\x6e\x61\x6d\x69\x63"})){__enableDebugDynamicallyForAll ();NXMsg::info 
(
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72");NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65");
return ((0x07cd+ 4426-0x1916));}if ((__enableDebugServer ()==
(0x0985+ 5732-0x1fe9))){return ((0x021b+ 7101-0x1dd8));}if ((__enableDebugNode 
()==(0x0e36+ 5355-0x2321))){return ((0x0b7b+ 3085-0x1788));}if (
NXLicense::isHttpdSupportFeature ()){if ((__enableDebugWebPlayer ()==
(0x192a+ 2342-0x2250))){return ((0x099f+ 5372-0x1e9b));}}if ((__enableDebugAgent
 ()==(0x21fc+ 1103-0x264b))){return ((0x06f1+ 4872-0x19f9));}return (
(0x1b34+ 2549-0x2528));}sub __enableDebugServer{(my $ref_parameters=shift (@_));
if (defined ($$ref_parameters{"\x64\x79\x6e\x61\x6d\x69\x63"})){
__enableDebugDynamicallyForServers ();NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72");return ((0x090f+ 7321-0x25a7));}(my $key=
$__serverLogLevelKey);(my $value=Logger::getDebugLevel ());(my $error=(""));if (
main::changeServerCfgKeySetError ($key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72");return ((0x085f+ 4412-0x199a));}else{NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x45\x6e\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72",$error);return ((0x0ed2+ 1757-0x15af));}}sub 
__enableDebugNode{(my $ref_parameters=shift (@_));if (defined ($$ref_parameters{
"\x64\x79\x6e\x61\x6d\x69\x63"})){__enableDebugDynamicallyForNodes ();
NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65");
return ((0x0730+ 5389-0x1c3c));}(my $key=$__serverLogLevelKey);(my $value=
Logger::getDebugLevel ());(my $error=(""));if (main::changeNodeCfgKeySetError (
$key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65");
return ((0x09f5+ 3914-0x193e));}else{NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x45\x6e\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65",
$error);return ((0x12ca+ 4621-0x24d7));}}sub __enableDebugWebPlayer{(my $key=
$__webplayerLogLevelKey);(my $value=Logger::getDebugLevel ());(my $error=(""));
if (main::changeServerCfgKeySetError ($key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x77\x65\x62\x70\x6c\x61\x79\x65\x72");return ((0x034a+ 6660-0x1d4d));}else{
NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x45\x6e\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x77\x65\x62\x70\x6c\x61\x79\x65\x72",$error);return ((0x18bc+ 3130-0x24f6));}}
sub __enableDebugAgent{(my $key=$__agentLogCleanKey);(my $value="\x30");(my $error
=(""));if (main::changeNodeCfgKeySetError ($key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x61\x67\x65\x6e\x74");return ((0x0dc2+ 3588-0x1bc5));}else{NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x45\x6e\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x61\x67\x65\x6e\x74",$error);return ((0x126f+ 3460-0x1ff3));}}sub 
__disableDebugAll{(my $ref_parameters=shift (@_));if (defined ($$ref_parameters{
"\x64\x79\x6e\x61\x6d\x69\x63"})){__disableDebugDynamicallyForAll ();NXMsg::info
 (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72");NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65");
return ((0x008b+ 1343-0x05c9));}if ((__disableDebugServer ()==
(0x1d16+ 420-0x1eba))){return ((0x0d60+ 6008-0x24d8));}if ((__disableDebugNode 
()==(0x00c8+ 4529-0x1279))){return ((0x03a5+ 2107-0x0be0));}if (
NXLicense::isHttpdSupportFeature ()){if ((__disableDebugWebPlayer ()==
(0x0f71+ 4512-0x2111))){return ((0x2382+ 557-0x25af));}}if ((__disableDebugAgent
 ()==(0x1bb4+ 1870-0x2302))){return ((0x0b01+ 4132-0x1b25));}return (
(0x0cb9+ 6377-0x25a1));}sub __disableDebugServer{(my $ref_parameters=shift (@_))
;if (defined ($$ref_parameters{"\x64\x79\x6e\x61\x6d\x69\x63"})){
__disableDebugDynamicallyForServers ();NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72");return ((0x2515+ 423-0x26bb));}(my $key=
$__serverLogLevelKey);(my $value=Logger::getInfoLevel ());(my $error=(""));if (
main::changeServerCfgKeySetError ($key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72");return ((0x0398+ 442-0x0551));}else{NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x44\x69\x73\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72",$error);return ((0x1a65+ 2413-0x23d2));}}sub 
__disableDebugNode{(my $ref_parameters=shift (@_));if (defined ($$ref_parameters
{"\x64\x79\x6e\x61\x6d\x69\x63"})){__disableDebugDynamicallyForNodes ();
NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65");
return ((0x04ab+ 8062-0x2428));}(my $key=$__serverLogLevelKey);(my $value=
Logger::getInfoLevel ());(my $error=(""));if (main::changeNodeCfgKeySetError (
$key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65");
return ((0x0158+ 6227-0x19aa));}else{NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x44\x69\x73\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65",
$error);return ((0x0086+ 8241-0x20b7));}}sub __disableDebugWebPlayer{(my $key=
$__webplayerLogLevelKey);(my $value=Logger::getInfoLevel ());(my $error=(""));if
 (main::changeServerCfgKeySetError ($key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x77\x65\x62\x70\x6c\x61\x79\x65\x72");return ((0x06c4+ 5539-0x1c66));}else{
NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x44\x69\x73\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x77\x65\x62\x70\x6c\x61\x79\x65\x72",$error);return ((0x249c+ 240-0x258c));}}
sub __disableDebugAgent{(my $key=$__agentLogCleanKey);(my $value="\x31");(my $error
=(""));if (main::changeNodeCfgKeySetError ($key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x61\x67\x65\x6e\x74");return ((0x17ef+ 1452-0x1d9a));}else{NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x44\x69\x73\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x61\x67\x65\x6e\x74",$error);return ((0x1955+ 2723-0x23f8));}}sub status{(my $serverNodeLogLevelKey
=$__serverLogLevelKey);(my $webplayerLogLevelKey=$__webplayerLogLevelKey);(my $agentLogCleanKey
=$__agentLogCleanKey);(my $disabled="\x64\x69\x73\x61\x62\x6c\x65\x64");(my $enabled
="\x65\x6e\x61\x62\x6c\x65\x64");(my $server="\x73\x65\x72\x76\x65\x72");(my $node
="\x6e\x6f\x64\x65");(my $webplayer="\x77\x65\x62\x70\x6c\x61\x79\x65\x72");(my $agent
="\x61\x67\x65\x6e\x74");(my $infoLevel=Logger::getInfoLevel ());my (
$serverLogLevel);my ($nodeLogLevel);my ($webplayerLogLevel);my ($agentLogClean);
(my $error=(""));(my $exitValue=(0x0eac+ 5805-0x2559));(($exitValue,
$serverLogLevel)=main::getValueFromConfigFileSetError ($GLOBAL::CONFIG_FILE,
$serverNodeLogLevelKey,(\$error)));if (($exitValue==(0x081d+  83-0x0870))){
NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x47\x65\x74\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$server,$error);}
elsif (($serverLogLevel>$infoLevel)){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$server,$enabled);}
else{NXMsg::info ("\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$server,$disabled);}
(($exitValue,$nodeLogLevel)=main::getValueFromConfigFileSetError (
$GLOBAL::NODE_CONFIG_FILE,$serverNodeLogLevelKey,(\$error)));if (($exitValue==
(0x039a+ 2900-0x0eee))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x47\x65\x74\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$node,$error);}elsif
 (($nodeLogLevel>$infoLevel)){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$node,$enabled);}else
{NXMsg::info ("\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$node,$disabled);}if 
(NXLicense::isHttpdSupportFeature ()){(($exitValue,$webplayerLogLevel)=
main::getValueFromConfigFileSetError ($GLOBAL::CONFIG_FILE,$webplayerLogLevelKey
,(\$error)));if (($exitValue==(0x1a9a+ 2127-0x22e9))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x47\x65\x74\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$webplayer,$error);}
elsif (($webplayerLogLevel>$infoLevel)){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$webplayer,$enabled);
}else{NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$webplayer,$disabled)
;}}(($exitValue,$agentLogClean)=main::getValueFromConfigFileSetError (
$GLOBAL::NODE_CONFIG_FILE,$agentLogCleanKey,(\$error)));if (($exitValue==
(0x0a73+ 3917-0x19c0))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x47\x65\x74\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$agent,$error);}
elsif (($agentLogClean eq "\x30")){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$agent,$enabled);}
else{NXMsg::info ("\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$agent,$disabled);}
return ((0x03e0+ 279-0x04f6));}sub collect{Logger::debug (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x53\x74\x61\x72\x74\x65\x64\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x63\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x20\x6c\x6f\x67\x73\x2e"
);NXMsg::info (
"\x69\x43\x4d\x44\x43\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x4c\x6f\x67\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");(my (@filesToCleanUp
)=());(my $result=__runScriptsSetCleanUpFiles ((\@filesToCleanUp)));if (($result
==(0x038b+ 4184-0x13e3))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");__cleanUpScriptLogs
 ((\@filesToCleanUp));return ((0x0e67+ 2627-0x18aa));}($result=
__createZipArchive ());if (($result==(0x0eb5+ 1979-0x1670))){__cleanUpScriptLogs
 ((\@filesToCleanUp));NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");return (
(0x06bf+ 3380-0x13f3));}__cleanUpScriptLogs ((\@filesToCleanUp));Logger::debug (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x50\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x63\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x20\x6c\x6f\x67\x73\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x2e"
);NXMsg::info (
"\x69\x43\x4d\x44\x43\x6f\x6c\x6c\x65\x63\x74\x65\x64\x4c\x6f\x67\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");warnIfSyslogEnabled 
();return ((0x1ff9+ 1494-0x25ce));}sub __createZipArchive{NXMsg::info (
"\x69\x43\x4d\x44\x43\x72\x65\x61\x74\x69\x6e\x67\x4c\x6f\x67\x41\x72\x63\x68\x69\x76\x65"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");(my (@paths)=());(my (
@names)=());(my $dateTime=Common::NXTime::getDateTimeForFileName ());(my $logFolderName
=("\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x2d\x6c\x6f\x67\x2d".$dateTime));
__setSpecialLogFolderPathAndName ((\@paths),(\@names),$logFolderName);
__setCommonLogFolderPathAndName ((\@paths),(\@names),$logFolderName);
__setAllUserLogFilesPathsAndNames ((\@paths),(\@names),$logFolderName);(my (
@excludePaths)=());push (@excludePaths,NXPaths::getLogArchivesPath ());push (
@excludePaths,NXPaths::getLogrotatePath ());(my $error=(""));(my $zipFile=
__getZipArchivePath ($logFolderName));(my $result=
Common::NXCore::createZipFileWithBestCompression ($zipFile,(\@paths),(\@names),(
\@excludePaths),(\$error)));if (($result!=(0x0647+ 2052-0x0e4a))){if (($result==
(-(0x0545+ 3899-0x147f)))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x41\x72\x63\x68\x69\x76\x65"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$error);}else{NXMsg::warning (
"\x77\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x70\x70\x65\x6e\x64\x41\x72\x63\x68\x69\x76\x65"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$zipFile,Common::NXPaths::getNXServerLogPath ())
;}return ((0x075d+ 991-0x0b3c));}else{NXMsg::info (
"\x69\x43\x4d\x44\x43\x72\x65\x61\x74\x65\x64\x4c\x6f\x67\x41\x72\x63\x68\x69\x76\x65"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$zipFile);}return ($result);}sub 
__cleanUpScriptLogs{(my $ref_cleanUpFiles=shift (@_));foreach my $file (
@$ref_cleanUpFiles){if ((Common::NXFile::fileExists ($file)and (not (unlink (
$file))))){Logger::warning ((((
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x73\x63\x72\x69\x70\x74\x20\x6c\x6f\x67\x20\x66\x69\x6c\x65\x3a\x20"
.$file)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20").$!));
Common::NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x52\x65\x6d\x6f\x76\x65\x46\x69\x6c\x65"
,$file,$!);}}}sub __getZipArchivePath{(my $logFolderName=shift (@_));(my $name=(
$logFolderName."\x2e\x7a\x69\x70"));(my $zipFile=((NXPaths::getLogArchivesPath 
().$GLOBAL::DIRECTORY_SLASH).$name));return ($zipFile);}sub 
__setSpecialLogFolderPathAndName{(my $ref_paths=shift (@_));(my $ref_names=shift
 (@_));(my $logFolderName=shift (@_));(my $logFolder=
Common::NXPaths::getSpecialUsersLogFolderPath ());push (@$ref_paths,$logFolder);
push (@$ref_names,$logFolderName);}sub __setCommonLogFolderPathAndName{(my $ref_paths
=shift (@_));(my $ref_names=shift (@_));(my $logFolderName=shift (@_));if ((
$GLOBAL::CommonLogDirectory ne (""))){push (@$ref_paths,
$GLOBAL::CommonLogDirectory);(my $commonLogName=($logFolderName.
"\x2f\x43\x6f\x6d\x6d\x6f\x6e\x4c\x6f\x67\x44\x69\x72\x65\x63\x74\x6f\x72\x79"))
;push (@$ref_names,$commonLogName);}}sub __setAllUserLogFilesPathsAndNames{(my $ref_paths
=shift (@_));(my $ref_names=shift (@_));(my $logFolderName=shift (@_));(my (
%users)=getUsersForLogCollection ());foreach my $user (keys (%users)){
__setUserLogFilesPathsAndNames ($user,$ref_paths,$ref_names,$logFolderName);}if 
(NXLicense::isHttpdSupportFeature ()){__setUserLogFilesPathsAndNames (
"\x6e\x78\x68\x74\x64",$ref_paths,$ref_names,$logFolderName);}}sub 
__getNxDirectoryInUserHomeDirectory{(my $user=shift (@_));if (($user eq 
"\x6e\x78\x68\x74\x64")){return (((
Common::NXPaths::getUserRealHomeDirectoryByUsername ($user).
$GLOBAL::DIRECTORY_SLASH)."\x2e\x6e\x78"));}else{return (
Common::NXPaths::getNxDirectoryInUserHomeDirectory ($user));}}sub 
__setUserLogFilesPathsAndNames{(my $user=shift (@_));(my $ref_paths=shift (@_));
(my $ref_names=shift (@_));(my $logFolderName=shift (@_));(my $nxDir=
__getNxDirectoryInUserHomeDirectory ($user));(my $nxserverLogPath=(($nxDir.
$GLOBAL::DIRECTORY_SLASH)."\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67"));(my $nodeDirPath
=(($nxDir.$GLOBAL::DIRECTORY_SLASH)."\x6e\x6f\x64\x65"));(my $nxserverLogName=(
$logFolderName.(("\x2f\x55\x73\x65\x72\x73\x2f".$user).
"\x2f\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67")));(my $nodeDirName=(
$logFolderName.(("\x2f\x55\x73\x65\x72\x73\x2f".$user)."\x2f\x6e\x6f\x64\x65")))
;if (Common::NXFile::fileExists ($nxserverLogPath)){push (@$ref_paths,
$nxserverLogPath);push (@$ref_names,$nxserverLogName);}if (
Common::NXFile::directoryExists ($nodeDirPath)){push (@$ref_paths,$nodeDirPath);
push (@$ref_names,$nodeDirName);}}sub __runScriptsSetCleanUpFiles{(my $ref_cleanUpFiles
=shift (@_));Logger::debug (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x53\x74\x61\x72\x74\x65\x64\x20\x73\x74\x65\x70\x3a\x20\x62\x65\x66\x6f\x72\x65\x20\x63\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x20\x6c\x6f\x67\x20\x73\x63\x72\x69\x70\x74\x73\x2e"
);(my $scriptsFolderPath=NXPaths::getCollectLogScriptsPath ());(my (@scripts)=()
);(my $error=(""));(my $result=Common::NXCore::listSortedFilesInDirectory (
$scriptsFolderPath,(\@scripts),(\$error)));if (($result==(0x1252+ 4325-0x2337)))
{NXMsg::info (
"\x69\x43\x4d\x44\x52\x75\x6e\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x73\x53\x74\x61\x72\x74"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x4c\x69\x73\x74\x46\x69\x6c\x65\x73\x44\x69\x72\x65\x63\x74\x6f\x72\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$scriptsFolderPath,
$error);return ((0x0994+ 6905-0x248d));}if (scalar (@scripts)){NXMsg::info (
"\x69\x43\x4d\x44\x52\x75\x6e\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x73\x53\x74\x61\x72\x74"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");}else{Logger::debug
 (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x42\x65\x66\x6f\x72\x65\x20\x63\x6f\x6c\x6c\x65\x63\x74\x20\x6c\x6f\x67\x20\x73\x63\x72\x69\x70\x74\x73\x20\x61\x72\x65\x20\x61\x62\x73\x65\x6e\x74\x2e"
);return ((0x0da2+ 1081-0x11da));}foreach my $script (@scripts){(my $scriptPath=
(($scriptsFolderPath.$GLOBAL::DIRECTORY_SLASH).$script));if ((not (-x (
$scriptPath)))){($result=
Common::NXFile::setPermissionFullForOwnerReadExecuteForAll ($scriptPath,(\$error
)));if (($result==(-(0x0c30+ 446-0x0ded)))){NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x50\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73"
,"\x4e\x58\x53\x68\x65\x6c\x6c",(($scriptPath."\x2e\x0a").$error));return (
(0x0af7+ 6531-0x247a));}}Logger::debug (((
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x52\x75\x6e\x6e\x69\x6e\x67\x20\x73\x63\x72\x69\x70\x74\x3a\x20"
.$scriptPath)."\x2e"));Common::NXMsg::info (
"\x69\x52\x75\x6e\x6e\x69\x6e\x67\x53\x63\x72\x69\x70\x74",$scriptPath);(my (
@command)=$scriptPath);(my (@parameters)=());push (@parameters,
"\x75\x73\x65\x20\x73\x63\x72\x69\x70\x74\x20\x74\x6f\x20\x6b\x69\x6c\x6c");push
 (@parameters,
"\x73\x65\x74\x20\x73\x74\x64\x65\x72\x72\x20\x61\x73\x20\x70\x69\x70\x65");
__setEnvironmentVariablesForScript ((\@parameters));(my ($cmd_err,$cmd_out,
$exit_value)=main::run_command ((\@command),(\@parameters)));if ($exit_value){
Logger::error ((((((
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x53\x63\x72\x69\x70\x74\x20\x66\x6f\x72\x20\x63\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x20\x6c\x6f\x67\x73\x3a\x20"
.$scriptPath)."\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x3a\x20"
).$exit_value)."\x2c\x20").$cmd_err));NXMsg::error (
"\x65\x43\x4d\x44\x45\x78\x65\x63\x75\x74\x69\x6f\x6e\x4f\x66\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x46\x61\x69\x6c\x65\x64"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$script,$cmd_err);
return ((0x03c9+ 7713-0x21ea));}($script=~ s/\.[^\.]*$/.log/ );(my $scriptsLogFile
=((Common::NXPaths::getSpecialUsersLogFolderPath ().$GLOBAL::DIRECTORY_SLASH).
$script));($result=__saveScriptLogs ($scriptsLogFile,$cmd_out));if (($result==
(0x01db+ 3514-0x0f95))){return ((0x0ed8+ 3945-0x1e41));}push (@$ref_cleanUpFiles
,$scriptsLogFile);}Logger::debug (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x46\x69\x6e\x69\x73\x68\x65\x64\x20\x73\x74\x65\x70\x3a\x20\x62\x65\x66\x6f\x72\x65\x20\x63\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x20\x6c\x6f\x67\x20\x73\x63\x72\x69\x70\x74\x73\x2e"
);NXMsg::info (
"\x69\x43\x4d\x44\x52\x75\x6e\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x73\x45\x6e\x64"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");return (
(0x0ada+ 1588-0x110d));}sub __setEnvironmentVariablesForScript{(my $ref_parameters
=shift (@_));push (@$ref_parameters,"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4e\x58\x5f\x42\x49\x4e\x5f\x50\x41\x54\x48\x3d".$GLOBAL::NODE_ROOT).
$GLOBAL::DIRECTORY_SLASH)."\x62\x69\x6e"));}sub __saveScriptLogs{(my $scriptLogFile
=shift (@_));(my $logs=shift (@_));(my $mode=($NXBits::O_CREAT+$NXBits::O_WRONLY
));(my $permissions=($NXBits::UserReadWrite+$NXBits::GroupReadWrite));(my $fd=
main::nxopen ($scriptLogFile,$mode,$permissions,{"\x45\x41\x43\x43\x45\x53",
"\x73\x69\x6c\x65\x6e\x74"}));if ((not (defined ($fd)))){Logger::error (((
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x3a\x20"
.$scriptLogFile).
"\x20\x74\x6f\x20\x73\x61\x76\x65\x20\x73\x63\x72\x69\x70\x74\x20\x6c\x6f\x67\x73\x2e"
));(my $errorString=libnxh::NXGetErrorString ());(my $error=(($scriptLogFile.
"\x2c\x20").$errorString));Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x46\x69\x6c\x65",$error);return (
(0x12a5+ 3932-0x2201));}if ((main::nxwrite ($fd,($logs."\x0a"))==(-
(0x114a+ 3342-0x1e57)))){Logger::error (((
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x3a\x20"
.$scriptLogFile).
"\x20\x74\x6f\x20\x73\x61\x76\x65\x20\x73\x63\x72\x69\x70\x74\x20\x6c\x6f\x67\x73\x2e"
));(my $errorString=libnxh::NXGetErrorString ());(my $error=(($scriptLogFile.
"\x2c\x20").$errorString));(my $path=Common::NXFile::dirname ($scriptLogFile));(my $file
=Common::NXFile::basename ($scriptLogFile));Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x57\x72\x69\x74\x65\x54\x6f\x46\x69\x6c\x65\x4f\x6e\x54\x68\x65\x4c\x6f\x63\x61\x6c\x48\x6f\x73\x74"
,$file,$path,$error);return ((0x04fb+ 2688-0x0f7b));}main::nxclose ($fd);return 
((0x09da+ 7091-0x258c));}sub __enableDebugDynamicallyForAll{(my $product=
"\x61\x6c\x6c");(my $value=Logger::getDebugLevel ());Logger::updateLogLevel (
$value);return (__sendDebugLevel ($product,$value));}sub 
__enableDebugDynamicallyForServers{(my $product="\x73\x65\x72\x76\x65\x72");(my $value
=Logger::getDebugLevel ());Logger::updateLogLevel ($value);return (
__sendDebugLevel ($product,$value));}sub __enableDebugDynamicallyForNodes{(my $product
="\x6e\x6f\x64\x65");(my $value=Logger::getDebugLevel ());return (
__sendDebugLevel ($product,$value));}sub __disableDebugDynamicallyForAll{(my $product
="\x61\x6c\x6c");(my $value=Logger::getInfoLevel ());Logger::updateLogLevel (
$value);return (__sendDebugLevel ($product,$value));}sub 
__disableDebugDynamicallyForServers{(my $product="\x73\x65\x72\x76\x65\x72");(my $value
=Logger::getInfoLevel ());Logger::updateLogLevel ($value);return (
__sendDebugLevel ($product,$value));}sub __disableDebugDynamicallyForNodes{(my $product
="\x6e\x6f\x64\x65");(my $value=Logger::getInfoLevel ());return (
__sendDebugLevel ($product,$value));}sub __sendDebugLevel{(my $product=shift (@_
));(my $value=shift (@_));(my $message=((((($GLOBAL::MSG_DEBUG_LOG_LEVEL.
"\x20\x70\x72\x6f\x64\x75\x63\x74\x3d").$product)."\x20\x76\x61\x6c\x75\x65\x3d"
).$value)."\x20"));main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::publishToSubscribers ($message);}sub 
handleDebugLogLevelMessage{(my $message=shift (@_));my ($product);my ($value);if
 (($message=~ /product=(.*) value=(.*) $/ )){($product=$1);($value=$2);}else{
Logger::error (((
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x49\x6e\x63\x6f\x72\x72\x65\x63\x74\x20\x66\x6f\x72\x6d\x61\x74\x20\x66\x6f\x72\x20\x64\x65\x62\x75\x67\x20\x6c\x6f\x67\x20\x6c\x65\x76\x65\x6c\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$message)."\x27\x2e"));return ((0x02ed+ 945-0x069e));}if (($product eq 
"\x73\x65\x72\x76\x65\x72")){Logger::updateLogLevel ($value);}elsif (($product 
eq "\x6e\x6f\x64\x65")){(my $nodeMessage=(("\x4e\x58\x3e\x20".$message)."\x0a"))
;NXNodeExec::sendToAllConnectedNodes ($nodeMessage);}elsif (($product eq 
"\x64\x61\x65\x6d\x6f\x6e")){if (Server::isDaemonProcess ()){
Logger::updateLogLevel ($value);main::nxrequire (
"\x50\x68\x79\x73\x69\x63\x53\x65\x73\x73\x69\x6f\x6e\x73");
PhysicSessions::updateLogLevel ($value);return ((0x05e9+ 2950-0x116f));}}else{
Logger::updateLogLevel ($value);if (Server::isDaemonProcess ()){main::nxrequire 
("\x50\x68\x79\x73\x69\x63\x53\x65\x73\x73\x69\x6f\x6e\x73");
PhysicSessions::updateLogLevel ($value);}(my $nodeMessage=(("\x4e\x58\x3e\x20".
$message)."\x0a"));NXNodeExec::sendToAllConnectedNodes ($nodeMessage);}return (
(0x0160+ 2952-0x0ce7));}sub warnIfSyslogEnabled{(my $product=(shift (@_)||("")))
;if (__isSyslogEnabledForProduct ($product)){NXMsg::warning (
"\x77\x43\x4d\x44\x53\x79\x73\x6c\x6f\x67\x45\x6e\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");}}sub 
__isSyslogEnabledForProduct{(my $product=shift (@_));if (((($product eq 
"\x6e\x6f\x64\x65")or ($product eq "\x61\x6c\x6c"))or ($product eq ("")))){(my (
$exitValue,$nodeSyslog)=main::getValueFromConfigFile ($GLOBAL::NODE_CONFIG_FILE,
$__syslogSupportKey));if (($nodeSyslog eq "\x31")){return ((0x0eb1+ 1169-0x1341)
);}elsif (($product eq "\x6e\x6f\x64\x65")){return ((0x0067+ 5962-0x17b1));}}if 
(($GLOBAL::EnableSyslogSupport eq "\x31")){return ((0x020f+ 2222-0x0abc));}
return ((0x026b+ 4551-0x1432));}sub addUserForLogCollection{(my $user=shift (@_)
);if (($user ne (""))){NXRedis::sendToDb (((((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x73\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x64\x65\x62\x75\x67\x75\x73\x65\x72\x73\x2c\x66\x69\x65\x6c\x64\x3d"
.$user)."\x2c\x76\x61\x6c\x75\x65\x3d").$user)."\x0a"));}else{Logger::debug (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x64\x6f\x20\x6e\x6f\x74\x20\x73\x65\x74\x20\x6c\x6f\x67\x20\x63\x6f\x6c\x6c\x65\x63\x74\x69\x6f\x6e\x20\x66\x6f\x72\x20\x65\x6d\x70\x74\x79\x20\x75\x73\x65\x72\x2e"
);}}sub getUsersForLogCollection{NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x67\x65\x74\x61\x6c\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x64\x65\x62\x75\x67\x75\x73\x65\x72\x73\x0a"
);return (split ( / / ,NXRedis::get (),(0x0f25+ 400-0x10b5)));}
NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
(0x1b61+ 544-0x19fd));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64",
(0x039a+ 1775-0x0705));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64",900);
NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x43\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x4c\x6f\x67\x73",
(0x12d9+ 4062-0x1f33));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x43\x6f\x6c\x6c\x65\x63\x74\x65\x64\x4c\x6f\x67\x73",
(0x2571+ 1258-0x26d7));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x52\x75\x6e\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x73\x53\x74\x61\x72\x74"
,(0x1134+ 5682-0x23e2));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x52\x75\x6e\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x73\x45\x6e\x64"
,(0x1b7f+ 749-0x1ae8));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x43\x72\x65\x61\x74\x69\x6e\x67\x4c\x6f\x67\x41\x72\x63\x68\x69\x76\x65"
,(0x0f07+ 5537-0x2124));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,(0x1fdd+ 177-0x1d0a));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,(0x0793+ 3900-0x134b));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x45\x6e\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,(0x0358+ 1750-0x083a));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x44\x69\x73\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,(0x0f99+ 2281-0x168e));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x47\x65\x74\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,(0x1b61+  69-0x19b2));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x45\x78\x65\x63\x75\x74\x69\x6f\x6e\x4f\x66\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x46\x61\x69\x6c\x65\x64"
,(0x09ca+ 3765-0x168b));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x4c\x69\x73\x74\x46\x69\x6c\x65\x73\x44\x69\x72\x65\x63\x74\x6f\x72\x79"
,(0x0ee8+ 1314-0x1216));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x73"
,(0x1971+ 1420-0x1d09));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x47\x65\x74\x43\x66\x67\x4b\x65\x79\x56\x61\x6c\x75\x65"
,(0x234d+ 499-0x234c));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x44\x79\x6e\x61\x6d\x69\x63\x44\x65\x62\x75\x67\x4e\x6f\x74\x53\x75\x70\x70\x6f\x72\x74\x65\x64"
,(0x04e7+ 568-0x052b));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x77\x43\x4d\x44\x53\x79\x73\x6c\x6f\x67\x45\x6e\x61\x62\x6c\x65\x64",
(0x141d+ 3907-0x216c));"\x3f\x3f\x3f";
